---
projectpages: "https://gitlab.com/preserves/preserves"
projecttree: "https://gitlab.com/preserves/preserves/tree/master"
title: "Preserves: an Expressive Data Language"
no_site_title: true
---

This [repository]({{page.projectpages}}) contains a
[proposal](preserves.html) and
[various implementations]({{page.projecttree}}/implementations/) of
*Preserves*, a new data model and serialization format in many ways
comparable to JSON, XML, S-expressions, CBOR, ASN.1 BER, and so on.

> **WARNING** Everything in this repository is experimental and in
> flux! The design of Preserves is not finalised and may change
> drastically. Please offer any feedback you may have with this in
> mind.

## Core documents

 - [Preserves tutorial](TUTORIAL.html)
 - [Preserves specification](preserves.html), including semantics,
   textual syntax, and compact binary syntax
 - [Canonical Form for Binary Syntax](canonical-binary.html)

## Additional resources

 - Some [conventions for common data types](conventions.html)
 - [Open questions](questions.html); see also the
   [issues list]({{page.projectpages}}/issues)
 - [Why not Just Use JSON?](why-not-json.html)

## Contact

Tony Garnock-Jones <tonyg@leastfixedpoint.com>

## Licensing

The contents of this repository are made available to you under the
[Apache License, version 2.0](LICENSE)
(<http://www.apache.org/licenses/LICENSE-2.0>), and are Copyright
2018-2019 Tony Garnock-Jones.
